<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title>How to create an add-on for Antidoc :: Wovalab open-source projects</title>
    <link rel="canonical" href="https://wovalab.gitlab.io/open-source/docs/antidoc/latest/create-addon/overview.html">
    <link rel="prev" href="../labview-api/overview.html">
    <meta name="generator" content="Antora 3.0.2">
    <link rel="stylesheet" href="../../../_/css/site.css">
    <script async src="https://www.googletagmanager.com/gtag/js?id=G-3KJN6K6QRD"></script>
    <script>function gtag(){dataLayer.push(arguments)};window.dataLayer=window.dataLayer||[];gtag('js',new Date());gtag('config','G-3KJN6K6QRD')</script>
    <script>var uiRootPath = '../../../_'</script>
    <link rel="icon" href="../../../favicon.ico" type="image/x-icon">  </head>
  <body class="article">
<header class="header">
  <nav class="navbar">
    <div class="navbar-brand">
      <a class="navbar-item logo" title="Wovalab" href="https://www.wovalab.com"><img src="../../../_/img/wovalab-light-vertical.svg" alt="Wovalab" width="64"></a>
      <a class="navbar-item" href="https://wovalab.gitlab.io/open-source/docs">Wovalab open-source projects</a>
      <div class="navbar-item search hide-for-print">
        <div id="search-field" class="field">
          <input id="search-input" type="text" placeholder="Search the docs">
          <label class="filter checkbox">
            <input type="checkbox" data-facet-filter="component:antidoc" checked> In this project
          </label>
        </div>
      </div>
      <button class="navbar-burger" data-target="topbar-nav">
        <span></span>
        <span></span>
        <span></span>
      </button>
    </div>
  </nav>
</header>
<div class="body">
<div class="nav-container" data-component="antidoc" data-version="2.0">
  <aside class="nav">
    <div class="panels">
<div class="nav-panel-menu is-active" data-panel="menu">
  <nav class="nav-menu">
    <h3 class="title"><a href="../index.html">Antidoc</a></h3>
<ul class="nav-list">
  <li class="nav-item" data-depth="0">
<ul class="nav-list">
  <li class="nav-item" data-depth="1">
    <a class="nav-link" href="../index.html">What&#8217;s new</a>
  </li>
  <li class="nav-item" data-depth="1">
    <a class="nav-link" href="../general-info.html">General information</a>
  </li>
</ul>
  </li>
  <li class="nav-item" data-depth="0">
<ul class="nav-list">
  <li class="nav-item" data-depth="1">
    <a class="nav-link" href="../labview-tool/overview.html">LabVIEW tool</a>
  </li>
</ul>
  </li>
  <li class="nav-item" data-depth="0">
<ul class="nav-list">
  <li class="nav-item" data-depth="1">
    <a class="nav-link" href="../labview-api/overview.html">LabVIEW API</a>
  </li>
</ul>
  </li>
  <li class="nav-item" data-depth="0">
<ul class="nav-list">
  <li class="nav-item is-current-page" data-depth="1">
    <a class="nav-link" href="overview.html">Create an add-on</a>
  </li>
</ul>
  </li>
</ul>
  </nav>
</div>
<div class="nav-panel-explore" data-panel="explore">
  <div class="context">
    <span class="title">Antidoc</span>
    <span class="version">2.0</span>
  </div>
  <ul class="components">
    <li class="component">
      <a class="title" href="../../../asciidoc-toolkit/latest/index.html">AsciiDoc toolkit</a>
      <ul class="versions">
        <li class="version is-latest">
          <a href="../../../asciidoc-toolkit/latest/index.html">1.8</a>
        </li>
        <li class="version">
          <a href="../../../asciidoc-toolkit/1.7/index.html">1.7</a>
        </li>
        <li class="version">
          <a href="../../../asciidoc-toolkit/1.6/index.html">1.6</a>
        </li>
      </ul>
    </li>
    <li class="component is-current">
      <a class="title" href="../index.html">Antidoc</a>
      <ul class="versions">
        <li class="version is-current is-latest">
          <a href="../index.html">2.0</a>
        </li>
      </ul>
    </li>
    <li class="component">
      <a class="title" href="../../../antidoc-addon-lvproj/latest/index.html">Antidoc add-on: LabVIEW project</a>
      <ul class="versions">
        <li class="version is-latest">
          <a href="../../../antidoc-addon-lvproj/latest/index.html">2.1</a>
        </li>
        <li class="version">
          <a href="../../../antidoc-addon-lvproj/2.0/index.html">2.0</a>
        </li>
      </ul>
    </li>
    <li class="component">
      <a class="title" href="../../../antidoc-addon-toolkit/latest/index.html">Antidoc add-on: LabVIEW toolkit</a>
      <ul class="versions">
        <li class="version is-latest">
          <a href="../../../antidoc-addon-toolkit/latest/index.html">2.0</a>
        </li>
      </ul>
    </li>
    <li class="component">
      <a class="title" href="../../../cli-tool-for-antidoc/latest/index.html">Antidoc CLI</a>
      <ul class="versions">
        <li class="version is-latest">
          <a href="../../../cli-tool-for-antidoc/latest/index.html">2.1</a>
        </li>
        <li class="version">
          <a href="../../../cli-tool-for-antidoc/2.0/index.html">2.0</a>
        </li>
        <li class="version">
          <a href="../../../cli-tool-for-antidoc/1.2.1/index.html">1.2.1</a>
        </li>
      </ul>
    </li>
    <li class="component">
      <a class="title" href="../../../about/index.html">Community</a>
    </li>
  </ul>
</div>    </div>
  </aside>
</div>
<main class="article">
<div class="toolbar" role="navigation">
<button class="nav-toggle"></button>
  <a href="../../../index.html" class="home-link"></a>
<nav class="breadcrumbs" aria-label="breadcrumbs">
  <ul>
    <li><a href="../index.html">Antidoc</a></li>
    <li><a href="overview.html">Create an add-on</a></li>
  </ul>
</nav>
  <div class="edit-this-page"><a href="https://gitlab.com/wovalab/open-source/labview-doc-generator/edit/docs/v2.0/docs/modules/create-addon/pages/overview.adoc">Edit this Page</a></div>
  </div>
  <div class="content">
<aside class="toc sidebar" data-title="Contents" data-levels="2">
  <div class="toc-menu"></div>
</aside>
<article class="doc">
<h1 class="page">How to create an add-on for Antidoc</h1>
<div id="preamble">
<div class="sectionbody">
<div class="admonitionblock note">
<table>
<tr>
<td class="icon">
<i class="fa icon-note" title="Note"></i>
</td>
<td class="content">
The <a href="https://gitlab.com/wovalab/open-source/antidoc-document-types/labview-toolkit-manual">LabVIEW Toolkit Manual</a> is probably the best project to glance at to see how to implement an add-on for Antidoc.
</td>
</tr>
</table>
</div>
</div>
</div>
<div class="sect1">
<h2 id="development-environment"><a class="anchor" href="#development-environment"></a>Development environment</h2>
<div class="sectionbody">
<div class="paragraph">
<p>Install the Antidoc package for the LabVIEW version you are targeting</p>
</div>
</div>
</div>
<div class="sect1">
<h2 id="steps-to-create-the-add-on-project"><a class="anchor" href="#steps-to-create-the-add-on-project"></a>Steps to create the add-on project</h2>
<div class="sectionbody">
<div class="olist arabic">
<ol class="arabic">
<li>
<p>Create and save a blank project</p>
</li>
</ol>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/blanc-project.png" alt="blanc project">
</div>
</div>
<div class="olist arabic">
<ol class="arabic" start="2">
<li>
<p>Add a library to the project</p>
</li>
</ol>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/document-type-lvlib.png" alt="document type lvlib">
</div>
</div>
<div class="olist arabic">
<ol class="arabic" start="2">
<li>
<p>Add a class to the library</p>
</li>
</ol>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/document-type-class.png" alt="document type class">
</div>
</div>
<div class="olist arabic">
<ol class="arabic" start="3">
<li>
<p>Make this class inherit from <code>Document Type</code></p>
</li>
</ol>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/document-type-inheritance.png" alt="document type inheritance">
</div>
</div>
<div class="olist arabic">
<ol class="arabic" start="4">
<li>
<p>Add a class to the library</p>
</li>
</ol>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/config-class.png" alt="config class">
</div>
</div>
<div class="olist arabic">
<ol class="arabic" start="5">
<li>
<p>Make this class inherit from <code>Config</code></p>
</li>
</ol>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/config-inheritance.png" alt="config inheritance">
</div>
</div>
<div class="admonitionblock important">
<table>
<tr>
<td class="icon">
<i class="fa icon-important" title="Important"></i>
</td>
<td class="content">
<div class="paragraph">
<p>To change the inheritance the parent class must be in memory. Load the <code>Config.lvclass</code> and <code>Document Type.lvclass</code> dropping a VI from the Antidoc functions palette to a VI diagram.</p>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/load-classes-in-memory.png" alt="load classes in memory">
</div>
</div>
</td>
</tr>
</table>
</div>
<div class="olist arabic">
<ol class="arabic" start="6">
<li>
<p>Override the required functions</p>
</li>
</ol>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/document-type-override-functions.png" alt="document type override functions">
</div>
</div>
</div>
</div>
<div class="sect1">
<h2 id="interface-call-order-in-antidoc"><a class="anchor" href="#interface-call-order-in-antidoc"></a>Interface call order in Antidoc</h2>
<div class="sectionbody">
<div class="paragraph">
<p>To understand how to override functions you need to understand how Antidoc is going to call the add-on code.</p>
</div>
<div class="paragraph">
<p>The following picture shows the call sequence (<code>/labview-doc-generator/Sources/Tool/Generate Project Documentation.vi</code>).</p>
</div>
<div class="imageblock">
<div class="content">
<img src="_images/calling-order-in-antidoc.png" alt="calling order in antidoc">
</div>
</div>
<div class="colist arabic">
<table>
<tr>
<td><i class="conum" data-value="1"></i><b>1</b></td>
<td>Open the select add-on dialog</td>
</tr>
<tr>
<td><i class="conum" data-value="2"></i><b>2</b></td>
<td>Update the config object</td>
</tr>
<tr>
<td><i class="conum" data-value="3"></i><b>3</b></td>
<td>Check if the add-on configuration is valid - SHOULD BE OVERRIDE</td>
</tr>
<tr>
<td><i class="conum" data-value="4"></i><b>4</b></td>
<td>Init the document creation - SHOULD BE OVERRIDE</td>
</tr>
<tr>
<td><i class="conum" data-value="5"></i><b>5</b></td>
<td>Parse the source of the documentation - MUST BE OVERRIDE</td>
</tr>
<tr>
<td><i class="conum" data-value="6"></i><b>6</b></td>
<td>Compose the final document - MUST BE OVERRIDE</td>
</tr>
<tr>
<td><i class="conum" data-value="7"></i><b>7</b></td>
<td>Release anything used during the documentation creation - SHOULD BE OVERRIDE</td>
</tr>
<tr>
<td><i class="conum" data-value="8"></i><b>8</b></td>
<td>Define the general documentation information - SHOULD BE OVERRIDE</td>
</tr>
<tr>
<td><i class="conum" data-value="9"></i><b>9</b></td>
<td>Save the configuration on disk to load it the next time the Antidoc UI is open</td>
</tr>
</table>
</div>
</div>
</div>
<div class="sect1">
<h2 id="purpose-of-override-functions-in-antidoc"><a class="anchor" href="#purpose-of-override-functions-in-antidoc"></a>Purpose of Override Functions in Antidoc</h2>
<div class="sectionbody">
<div class="paragraph">
<p>The classes in the <code>Blocs</code> folder of the add-on project represent the sections of the document, and each of these inherits from Antidoc&#8217;s bloc class.</p>
</div>
<div class="ulist">
<ul>
<li>
<p><code>Render.vi</code> (override VI) in each bloc class should put content into the blocs, formatted using AsciiDoctor functions</p>
</li>
</ul>
</div>
<div class="paragraph">
<p>Additionally</p>
</div>
<div class="ulist">
<ul>
<li>
<p><code>Parse.vi</code> in <code>&lt;add-on name&gt;.lvclass</code> is where the information for the content is read in (e.g. from LabVIEW/ TestStand file ref)</p>
</li>
<li>
<p><code>Compose.vi</code> is for adding blocs into sections and organising the different sections</p>
</li>
</ul>
</div>
</div>
</div>
<nav class="pagination">
  <span class="prev"><a href="../labview-api/overview.html">LabVIEW API</a></span>
</nav>
</article>
  </div>
</main>
</div>
<footer class="footer">
  <p>Wovalab © 2018-2022</p>
</footer>
<script id="site-script" src="../../../_/js/site.js" data-ui-root-path="../../../_"></script>
<script async src="../../../_/js/vendor/highlight.js"></script>
<script src="../../../_/js/vendor/lunr.js"></script>
<script src="../../../_/js/search-ui.js" id="search-ui-script" data-site-root-path="../../.." data-snippet-length="100" data-stylesheet="../../../_/css/search.css"></script>
<script async src="../../../search-index.js"></script>
  </body>
</html>
